//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Server.ObservableCommandTest
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Count command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class CountRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.IntegerDto _n;
        
        private Tecan.Sila2.RealDto _delay;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public CountRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="n">Number to count to</param>
        /// <param name="delay">The delay for each iteration</param>
        public CountRequestDto(long n, double delay, Tecan.Sila2.IBinaryStore store)
        {
            N = new Tecan.Sila2.IntegerDto(n, store);
            Delay = new Tecan.Sila2.RealDto(delay, store);
        }
        
        /// <summary>
        /// Number to count to
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto N
        {
            get
            {
                return _n;
            }
            set
            {
                _n = value;
            }
        }
        
        /// <summary>
        /// The delay for each iteration
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.RealDto Delay
        {
            get
            {
                return _delay;
            }
            set
            {
                _delay = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/ObservableCommandTest/v1/Command/Count";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(N, "n");
            Argument.Validate(Delay, "delay");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return (("" + Argument.Require(N, "n")) 
                        + Argument.Require(Delay, "delay"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the intermediate response of the Count command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class CountIntermediateDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.IntegerDto _currentIteration;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public CountIntermediateDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="currentIteration">The current number, from 0 to N-1 (excluded).</param>
        public CountIntermediateDto(long currentIteration, Tecan.Sila2.IBinaryStore store)
        {
            CurrentIteration = new Tecan.Sila2.IntegerDto(currentIteration, store);
        }
        
        /// <summary>
        /// The current number, from 0 to N-1 (excluded).
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto CurrentIteration
        {
            get
            {
                return _currentIteration;
            }
            set
            {
                _currentIteration = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(CurrentIteration, "currentIteration");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(CurrentIteration, "currentIteration"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Count command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class CountResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.IntegerDto _iterationResponse;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public CountResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="iterationResponse">The last number (N-1)</param>
        public CountResponseDto(long iterationResponse, Tecan.Sila2.IBinaryStore store)
        {
            IterationResponse = new Tecan.Sila2.IntegerDto(iterationResponse, store);
        }
        
        /// <summary>
        /// The last number (N-1)
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto IterationResponse
        {
            get
            {
                return _iterationResponse;
            }
            set
            {
                _iterationResponse = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(IterationResponse, "iterationResponse");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(IterationResponse, "iterationResponse"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Echo Value After Delay command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoValueAfterDelayRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.IntegerDto _value;
        
        private Tecan.Sila2.RealDto _delay;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoValueAfterDelayRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="value">The value to echo</param>
        /// <param name="delay">The delay before the command execution starts</param>
        public EchoValueAfterDelayRequestDto(long value, double delay, Tecan.Sila2.IBinaryStore store)
        {
            Value = new Tecan.Sila2.IntegerDto(value, store);
            Delay = new Tecan.Sila2.RealDto(delay, store);
        }
        
        /// <summary>
        /// The value to echo
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// The delay before the command execution starts
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.RealDto Delay
        {
            get
            {
                return _delay;
            }
            set
            {
                _delay = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/ObservableCommandTest/v1/Command/EchoValueAfterDelay";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Value, "value");
            Argument.Validate(Delay, "delay");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return (("" + Argument.Require(Value, "value")) 
                        + Argument.Require(Delay, "delay"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Echo Value After Delay command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class EchoValueAfterDelayResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.IntegerDto _receivedValue;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public EchoValueAfterDelayResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="receivedValue">The Received Value</param>
        public EchoValueAfterDelayResponseDto(long receivedValue, Tecan.Sila2.IBinaryStore store)
        {
            ReceivedValue = new Tecan.Sila2.IntegerDto(receivedValue, store);
        }
        
        /// <summary>
        /// The Received Value
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto ReceivedValue
        {
            get
            {
                return _receivedValue;
            }
            set
            {
                _receivedValue = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ReceivedValue, "receivedValue");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(ReceivedValue, "receivedValue"));
        }
    }
}
